package java.nio;

import java.io.FileDescriptor;
import sun.nio.ch.DirectBuffer;

class DirectByteBufferR extends DirectByteBuffer implements DirectBuffer
{
    DirectByteBufferR(int n) {
        super(n);
    }
    
    protected DirectByteBufferR(int n, long n2, FileDescriptor fileDescriptor, Runnable runnable) {
        super(n, n2, fileDescriptor, runnable);
    }
    
    DirectByteBufferR(DirectBuffer directBuffer, int n, int n2, int n3, int n4, int n5) {
        super(directBuffer, n, n2, n3, n4, n5);
    }
    
    @Override
    public ByteBuffer slice() {
        int position = this.position();
        int limit = this.limit();
        int n = (position <= limit) ? (limit - position) : 0;
        int n2 = position << 0;
        assert n2 >= 0;
        return new DirectByteBufferR(this, -1, 0, n, n, n2);
    }
    
    @Override
    public ByteBuffer duplicate() {
        return new DirectByteBufferR(this, this.markValue(), this.position(), this.limit(), this.capacity(), 0);
    }
    
    @Override
    public ByteBuffer asReadOnlyBuffer() {
        return this.duplicate();
    }
    
    @Override
    public ByteBuffer put(byte b) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer put(int n, byte b) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer put(ByteBuffer byteBuffer) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer put(byte[] array, int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer compact() {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public boolean isDirect() {
        return true;
    }
    
    @Override
    public boolean isReadOnly() {
        return true;
    }
    
    @Override
    byte _get(int n) {
        return DirectByteBufferR.unsafe.getByte(this.address + (long)n);
    }
    
    @Override
    void _put(int n, byte b) {
        throw new ReadOnlyBufferException();
    }
    
    private ByteBuffer putChar(long n, char c) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putChar(char c) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putChar(int n, char c) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public CharBuffer asCharBuffer() {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n = ((position <= limit) ? (limit - position) : 0) >> 1;
        if (!DirectByteBufferR.unaligned && (this.address + (long)position) % 2L != 0L) {
            return this.bigEndian ? new ByteBufferAsCharBufferRB(this, -1, 0, n, n, position) : new ByteBufferAsCharBufferRL(this, -1, 0, n, n, position);
        }
        return this.nativeByteOrder ? new DirectCharBufferRU(this, -1, 0, n, n, position) : new DirectCharBufferRS(this, -1, 0, n, n, position);
    }
    
    private ByteBuffer putShort(long n, short n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putShort(short n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putShort(int n, short n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ShortBuffer asShortBuffer() {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n = ((position <= limit) ? (limit - position) : 0) >> 1;
        if (!DirectByteBufferR.unaligned && (this.address + (long)position) % 2L != 0L) {
            return this.bigEndian ? new ByteBufferAsShortBufferRB(this, -1, 0, n, n, position) : new ByteBufferAsShortBufferRL(this, -1, 0, n, n, position);
        }
        return this.nativeByteOrder ? new DirectShortBufferRU(this, -1, 0, n, n, position) : new DirectShortBufferRS(this, -1, 0, n, n, position);
    }
    
    private ByteBuffer putInt(long n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putInt(int n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putInt(int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public IntBuffer asIntBuffer() {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n = ((position <= limit) ? (limit - position) : 0) >> 2;
        if (!DirectByteBufferR.unaligned && (this.address + (long)position) % 4L != 0L) {
            return this.bigEndian ? new ByteBufferAsIntBufferRB(this, -1, 0, n, n, position) : new ByteBufferAsIntBufferRL(this, -1, 0, n, n, position);
        }
        return this.nativeByteOrder ? new DirectIntBufferRU(this, -1, 0, n, n, position) : new DirectIntBufferRS(this, -1, 0, n, n, position);
    }
    
    private ByteBuffer putLong(long n, long n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putLong(long n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putLong(int n, long n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public LongBuffer asLongBuffer() {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n = ((position <= limit) ? (limit - position) : 0) >> 3;
        if (!DirectByteBufferR.unaligned && (this.address + (long)position) % 8L != 0L) {
            return this.bigEndian ? new ByteBufferAsLongBufferRB(this, -1, 0, n, n, position) : new ByteBufferAsLongBufferRL(this, -1, 0, n, n, position);
        }
        return this.nativeByteOrder ? new DirectLongBufferRU(this, -1, 0, n, n, position) : new DirectLongBufferRS(this, -1, 0, n, n, position);
    }
    
    private ByteBuffer putFloat(long n, float n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putFloat(float n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putFloat(int n, float n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public FloatBuffer asFloatBuffer() {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n = ((position <= limit) ? (limit - position) : 0) >> 2;
        if (!DirectByteBufferR.unaligned && (this.address + (long)position) % 4L != 0L) {
            return this.bigEndian ? new ByteBufferAsFloatBufferRB(this, -1, 0, n, n, position) : new ByteBufferAsFloatBufferRL(this, -1, 0, n, n, position);
        }
        return this.nativeByteOrder ? new DirectFloatBufferRU(this, -1, 0, n, n, position) : new DirectFloatBufferRS(this, -1, 0, n, n, position);
    }
    
    private ByteBuffer putDouble(long n, double n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putDouble(double n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public ByteBuffer putDouble(int n, double n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public DoubleBuffer asDoubleBuffer() {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n = ((position <= limit) ? (limit - position) : 0) >> 3;
        if (!DirectByteBufferR.unaligned && (this.address + (long)position) % 8L != 0L) {
            return this.bigEndian ? new ByteBufferAsDoubleBufferRB(this, -1, 0, n, n, position) : new ByteBufferAsDoubleBufferRL(this, -1, 0, n, n, position);
        }
        return this.nativeByteOrder ? new DirectDoubleBufferRU(this, -1, 0, n, n, position) : new DirectDoubleBufferRS(this, -1, 0, n, n, position);
    }
}
